//////////////////////////////////////
//	[CPColor.h]						//
//	FǗNX				//
//	from 2000.11.17					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPCOLOR_H
#define _CPCOLOR_H

#include "CPartsMain.h"
#include "CPGraphics.h"

class CPWindow;

class CPColor;
typedef void (* LP_COLORPROC)(CPColor *);

class LibExport CPColor : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY256

public:
	CP_SHLIB_DUMMY128

	CPColor();
	CPColor(int R,int G,int B);
	CPColor(CPSTColor col);
	~CPColor();

	//--------------------------//
	//	F̐ݒ				//
	//--------------------------//
	void SetColorRGB(int R,int G,int B);			//RGBli[
	void SetColorRGB(CPSTColor col);				//RGBli[
	void SetColorHSV(int H,int S,int V);			//HSVli[

	//--------------------------//
	//	F̎擾				//
	//--------------------------//
	void GetColorRGB(int *lpR,int *lpG,int *lpB);	//RGBl擾
	CPSTColor GetColorRGB();						//RGBl擾
	int GetRedValue();								//Redl߂
	int GetGreenValue();							//Greenl߂
	int GetBlueValue();								//Bluel߂
	void GetColorHSV(int *lpH,int *lpS,int *lpV);	//HSVl擾

	//--------------------------//
	//	Fϊ				//
	//--------------------------//
	void RGBtoHSV(int R,int G,int B,int *lpH,int *lpS,int *lpV);	//RGBlHSVl߂
	void HSVtoRGB(int H,int S,int V,int *lpR,int *lpG,int *lpB);	//HSVlRGBl߂
	CPSTColor HSVtoRGB(int H,int S,int V);					//HSVlRGBl߂

	//--------------------------//
	//	J[_CAO		//
	//--------------------------//
	unsigned long ColorDialog(unsigned long col);
	
	//------------------------------//
	//	ȉAGUIiƂĔzup	//
	//------------------------------//
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ
	void SetEnable(CP_BOOL f);						//Lɂ邩Ȃ
	void SetColor(unsigned long col){
		SetColorRGB(CP_RGB_RED(col),CP_RGB_GREEN(col),CP_RGB_BLUE(col));
	}

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ
	CP_BOOL IsEnable();								//Lɂ邩Ȃ
	unsigned long GetColor(){
		return CP_RGB(GetRedValue(),GetGreenValue(),GetBlueValue());
	}

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
	
	//----- Cxg̑Ή -----
	CP_BOOL AttachChangeEvent(LP_COLORPROC lpProc);		//FύXꂽꍇ̃Cxg󂯎
	void DetachChangeEvent();							//Cxg̉

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

	//------------------------------//
	//	OSˑ̏擾			//
	//------------------------------//
	unsigned long GetSystem_WindowBackgroundColor();	//VXeł̃EBhE̔wiF擾

};

#endif
