//////////////////////////////////////
//	[CPGroup.h]						//
//	O[vg`EǗNX		//
//	from 2001.02.06					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPGROUP_H
#define _CPGROUP_H

#include "CPartsMain.h"
#include "CPGraphics.h"

#include "CPLabel.h"
#include "CPPushButton.h"
#include "CPEditBox.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPRadioButton.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"
#include "CPColor.h"
#include "CPButton.h"
#include "CPListBox.h"

class CPGroup;
typedef void (* LP_GROUPPROC)(CPGroup *lpGroup);

#define CP_GROUP_NOBORDER	0	//^CgȂ̃O[v
#define CP_GROUP_BORDER		1	//ĝ݂̃O[v
#define CP_GROUP_CAPTION	2	//^Cgt̃O[v

class LibExport CPGroup : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY512

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPGroup();
	~CPGroup();

	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetMode(int m);							//O[ṽ[h
	void SetText(char *lpStr);						//\镶w
	void SetBackMode(int mode);						//wi𓧖ɂ邩w
	void SetBackgroundColor(unsigned long col);		//wiFw
	void SetForegroundColor(unsigned long col);		//OiFw

	void Clear();				//ׂĉ

	//--------------------------------------//
	//	GUIRg[EBhEɒǉ	//
	//--------------------------------------//
	void Add(CPLabel *lpLabel);
	void Add(CPPushButton *lpPushButton);
	void Add(CPEditBox *lpEditBox);
	void Add(CPGroup *lpGroup);
	void Add(CPProgressBar *lpProgressBar);
	void Add(CPCheckBox *lpCheckBox);
	void Add(CPRadioButton *lpRadioButton);
	void Add(CPSlider *lpSlider);
	void Add(CPTab *lpTab);
	void Add(CPComboBox *lpComboBox);
	void Add(CPSpin *lpSpin);
	void Add(CPSpinEditBox *lpSpinEditBox);
	void Add(CPImage *lpImage);
	void Add(CPColor *lpColor);		//C-Parts Ver1.07
	void Add(CPButton *lpButton);	//C-Parts Ver1.07
	void Add(CPListBox *lpListBox);	//C-Parts Ver1.08

	//--------------------------------------//
	//	GUIRg[O[v폜	//
	//--------------------------------------//
	void RemoveAt(CPLabel *lpLabel);
	void RemoveAt(CPPushButton *lpPushButton);
	void RemoveAt(CPEditBox *lpEditBox);
	void RemoveAt(CPGroup *lpGroup);
	void RemoveAt(CPProgressBar *lpProgressBar);
	void RemoveAt(CPCheckBox *lpCheckBox);
	void RemoveAt(CPRadioButton *lpRadioButton);
	void RemoveAt(CPSlider *lpSlider);
	void RemoveAt(CPTab *lpTab);
	void RemoveAt(CPComboBox *lpComboBox);
	void RemoveAt(CPSpin *lpSpin);
	void RemoveAt(CPSpinEditBox *lpSpinEditBox);
	void RemoveAt(CPImage *lpImage);
	void RemoveAt(CPColor *lpColor);		//C-Parts Ver1.07
	void RemoveAt(CPButton *lpButton);		//C-Parts Ver1.07
	void RemoveAt(CPListBox *lpListBox);	//C-Parts Ver1.08

	//w̃WI{^`FbNȋ̃`FbN͂͂j
	void SelectRadioButton(CPRadioButton *lpRadio);
	CP_BOOL SelectRadioButton(int n);					//wԖڂ̃WI{^I
		
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	void GetText(char *lpStr,int StrLen);			//\镶擾
	int GetMode();									//O[ṽ[h̎擾
	int GetBackMode();								//wi𓧖ɂ邩ǂ̃[h擾
	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾

	int GetRadioButton();							//ǂ̃WI{^IĂ邩̃CfbNX擾
	int GetRadioButtonCount();						//WI{^̐擾

	//----- Cxg̑Ή -----
	CP_BOOL AttachRadioButtonSelectEvent(LP_GROUPPROC lpProc);			//WI{^ꂽꍇ̃Cxg󂯎
	void DetachRadioButtonSelectEvent();			//Cxg̉

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
};

#endif
