//////////////////////////////////////
//	[CPImage.h]						//
//	摜E`NX			//
//	from 2001.11.05					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPIMAGE_H
#define _CPIMAGE_H

#include "CPartsMain.h"
#include "CPGraphics.h"

typedef void (* LP_IMAGE_GLPROC)();

class LibExport CPImage
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY512

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPImage();
	~CPImage();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void Clear();				//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s
	
	//----- 摜Ŏgp֐ -----
	int GetLineBytes();								//1s̃oCg
	int GetImageWidth();							//摜̕擾
	int GetImageHeight();							//摜̍擾
	void *GetPointer();								//摜̊Jn|C^擾
	void ClearImage(unsigned long col);				//w̐Fŉ摜NA

	//----- `֐ -----
	//`Fݒ
	void SetForegroundColor(unsigned long col);

	//_`
	void SetPixel(int x,int y);
	
	//_̐F擾
	unsigned long GetPixel(int x,int y);

	//`
	void DrawLine(int x1,int y1,int x2,int y2);

	//`
	void DrawHLine(int x1,int y,int x2);

	//`
	void DrawVLine(int x,int y1,int y2);

	//``
	void DrawRect(int x1,int y1,int x2,int y2);

	//`hԂ`
	void DrawFillRect(int x1,int y1,int x2,int y2);

	//~`
	void DrawCircle(int cx,int cy,int r);

	//~hԂ̕`
	void DrawFillCircle(int cx,int cy,int r);

	//|S̕`
	void DrawPolygon(CPSTPosition *lpPos,int num);

	//hԂ|S̕`
	void DrawFillPolygon(CPSTPosition *lpPos,int num);

	//xWFȐ̕`
	void DrawBezier(CPSTPosition *lpPos,int num);

	//----- 摜ǂݍ݊֐ -----
	CP_BOOL LoadImage(char *lpFName,int sx,int sy,int sWidth,int sHeight,int px,int py);
	//摜TCY̓ǂ݂Ƃ
	CP_BOOL GetImageSize(char *lpFName,int *lpWidth,int *lpHeight);

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

	//----- OpenGL̐p(C-Parts Ver1.07) -----
	CP_BOOL AttachOpenGL(CPWindow *lpWin,LP_IMAGE_GLPROC lpProc);	//OpenGL[hɂ
	CP_BOOL AttachOpenGL(CPGroup *lpGroup,LP_IMAGE_GLPROC lpProc);	//OpenGL[hɂ

};

#endif
