//////////////////////////////////////
//	[CPWindow.h]					//
//	EBhEǗNX		//
//	from 2000.11.18					//
//	to   2002.07.26					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPWINDOW_H
#define _CPWINDOW_H

#include "CPartsMain.h"
#include "CPGraphics.h"

#include "CPLabel.h"
#include "CPPushButton.h"
#include "CPEditBox.h"
#include "CPGroup.h"
#include "CPProgressBar.h"
#include "CPCheckBox.h"
#include "CPSlider.h"
#include "CPTab.h"
#include "CPComboBox.h"
#include "CPSpin.h"
#include "CPSpinEditBox.h"
#include "CPImage.h"
#include "CPColor.h"
#include "CPButton.h"
#include "CPListBox.h"
#include "CPCursor.h"
#include "CPScrollArea.h"

//\EBhE̎ށiCreateNewWindow()ł́Agݍ킹Ďgpj
#define CP_WINDOW_RESIZE		0x00000001		//TCY\ȃEBhE
#define CP_WINDOW_TOOLWINDOW	0x00000002		//c[EBhẼ^Cgo[
#define CP_WINDOW_MODALDIALOG	0x00000004		//[__CAO

class CPWindow;

typedef void (* LP_KEYPROC)(CPWindow *,CPSTKeyEvent);
typedef void (* LP_MOUSEPROC)(CPWindow *,CPSTMouseEvent);
typedef void (* LP_WINDOWPROC)(CPWindow *,CPSTWindowEvent);
typedef void (* LP_TIMERPROC)(CPWindow *);

class LibExport CPWindow : public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY2048

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPWindow();
	~CPWindow();

	//EBhE𐶐
	int CreateNewWindow(char *lpCaption,int x,int y,int wid,int hei,int mode);

	//i[_ȁj_CAO𐶐
	int CreateNewDialog(char *lpCaption,int x,int y,int wid,int hei);

	//EBhE̕\
	CP_BOOL ShowWindow(CP_BOOL showF);

	//[__CAO̕\
	CP_BOOL DoModal();

	//EBhEIDԂ
	int GetWinID();

	//EBhE̕`XV
	void UpdateWindow();

	//EBhE̕`w̋`ōXV
	void UpdateWindowRect(int x1,int y1,int x2,int y2);

	//wiFݒ
	void SetBackgroundColor(unsigned long col);		//wiFw

	//wiF̎擾
	unsigned long GetBackgroundColor();

	void BeginPaint();	//EBhE̕`Jn
	void EndPaint();	//EBhE̕`I

	void CloseWindow();	//EBhE̔j
	
	void Clear();									//ׂĉ

	//--------------------------------------//
	//	GUIRg[Ԃ̈ړȂ			//
	//--------------------------------------//
	void NextFocus();		//GUIRg[Ɉړ

	//--------------------------------------//
	//	GUIRg[EBhEɒǉ	//
	//--------------------------------------//
	void Add(CPLabel *lpLabel);
	void Add(CPPushButton *lpPushButton);
	void Add(CPEditBox *lpEditBox);
	void Add(CPGroup *lpGroup);
	void Add(CPProgressBar *lpProgressBar);
	void Add(CPCheckBox *lpCheckBox);
	void Add(CPSlider *lpSlider);
	void Add(CPTab *lpTab);
	void Add(CPComboBox *lpComboBox);
	void Add(CPSpin *lpSpin);
	void Add(CPSpinEditBox *lpSpinEditBox);
	void Add(CPImage *lpImage);
	void Add(CPColor *lpColor);				//C-Parts Ver1.07
	void Add(CPButton *lpButton);			//C-Parts Ver1.07
	void Add(CPListBox *lpListBox);			//C-Parts Ver1.08
	void Add(CPScrollArea *lpScrollArea);	//C-Parts Ver1.10

	//--------------------------------------//
	//	GUIRg[O[v폜	//
	//--------------------------------------//
	void RemoveAt(CPLabel *lpLabel);
	void RemoveAt(CPPushButton *lpPushButton);
	void RemoveAt(CPEditBox *lpEditBox);
	void RemoveAt(CPGroup *lpGroup);
	void RemoveAt(CPProgressBar *lpProgressBar);
	void RemoveAt(CPCheckBox *lpCheckBox);
	void RemoveAt(CPSlider *lpSlider);
	void RemoveAt(CPTab *lpTab);
	void RemoveAt(CPComboBox *lpComboBox);
	void RemoveAt(CPSpin *lpSpin);
	void RemoveAt(CPSpinEditBox *lpSpinEditBox);
	void RemoveAt(CPImage *lpImage);
	void RemoveAt(CPColor *lpColor);			//C-Parts Ver1.07
	void RemoveAt(CPButton *lpButton);			//C-Parts Ver1.07
	void RemoveAt(CPListBox *lpListBox);		//C-Parts Ver1.08
	void RemoveAt(CPScrollArea *lpScrollArea);	//C-Parts Ver1.10

	//----------------------------------------------//
	//	eCxg󂯎|C^A^b`		//
	//----------------------------------------------//
	//EBhECxg󂯎֐ݒ
	void AttachWindowEvent(LP_WINDOWPROC WindowEvent);
	//Cxg̉
	void DetachWindowEvent();

	//L[{[hCxg󂯎֐ݒ
	void AttachKeyEvent(LP_KEYPROC KeyEvent);
	//Cxg̉
	void DetachKeyEvent();

	//}EXCxg󂯎֐ݒ
	void AttachMouseEvent(LP_MOUSEPROC MouseEvent);
	//Cxg̉
	void DetachMouseEvent();

	//^C}[Cxg󂯎֐ݒ
	void AttachTimerEvent(LP_TIMERPROC TimerEvent);
	//Cxg̉
	void DetachTimerEvent();
	
	//L[͏̏Ԏ擾
	//KeyCode ... ׂL[R[h
	//߂l   .. Ă邩ǂ
	CP_BOOL GetKeyState(int KeyCode);

#ifdef macintosh
	//Macł̂P̃Cxgs
	CP_BOOL MacEventProc(EventRecord ev);
	
	//MacłNULLCxg̏s
	CP_BOOL MacNULLEventProc();
	
#endif

	//bZ[W{bNX\(2001.12.31 ǉ)
	void MessageBox(char *lpTitle,char *lpStr);

	//EBhEɑ邷ׂĂ̕ĩtH[JX𖳌ɂ(C-Parts Ver1.07)
	void AllFocusClear();

	//}EXʒu擾(C-Parts Ver1.07)
	CPSTPosition GetMousePosition();

	//EBhËʒu擾(C-Parts Ver1.08)
	CPSTPosition GetWindowPosition();

	//EBhE̕\Ԃ擾(C-Parts Ver1.08)
	CP_BOOL IsVisible();

	//}EXJ[\쐬iC-Parts Ver1.10j
	CP_BOOL CreateCursor(unsigned char *pBuff,unsigned char *pMaskBuff,int cx,int cy);

	//}EXJ[\ύXiC-Parts Ver1.10j
	CP_BOOL SetCursor(int n);

	//}EXJ[\擾iC-Parts Ver1.10j
	int GetCursor();
};

#endif
