//////////////////////////////////////
//	[CPartsSI.cpp]					//
//	C-PartsShadeŗp邽߂	//
//	C^[tF[X				//
//	2002.04.05 - 2002.06.05			//
//	by Yutaka Yoshisaka				//
//////////////////////////////////////
struct allocator_class { };

#include <vector>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "CPartsSI.h"
#include "CPartsMain.h"

//ȉID́AevOCƂɕύXĂB
#include "imageinterface.h"
#include "renderinginterface.h"
#include "pointer.h"
#include "shadeversion.h"

#ifdef _WINDOWS
#include "windows.h"
#endif

static int g_StartF=0;
static shade_interface *g_si_shade=NULL;


#ifdef _WINDOWS
//----------------------------------//
//ShadẽEBhEnh擾	//
//----------------------------------//
static HWND GetShadeHwnd(scene_interface *scene)
{
	HWND hwnd=NULL;

	if(scene){
		//ShadẽEBhEnh擾
		try {
			hwnd=(HWND)scene->get_main_window();
		} catch(...){ }
	} else {
		//݊ۂ߂̏ii͎gpȂƁIj
		HWND hParent;

		hwnd=GetForegroundWindow();	//݂̃ANeBuȃEBhE

		if(hwnd==NULL) return NULL;
		hParent=GetParent(hwnd);			//eEBhEiShade{̂j

		if(hParent) return hParent;
	}

	return hwnd;
}
#endif

//--------------------------//
//	C-Parts 		//
//--------------------------//
void CPartsSI_Initialize(scene_interface *scene)
{
	if(g_StartF) return;

#if _WINDOWS
	//eEBhẼCX^Xnh擾(Windowŝ݁j
	HWND parentWnd;
	HINSTANCE mInst;
	parentWnd=GetShadeHwnd(scene);
	if(!parentWnd) return;			//eEBhE̎擾Ɏs邱Ƃ

	mInst=(HINSTANCE)((HANDLE)GetWindowLong(parentWnd,GWL_HINSTANCE));

	//C-Parts̏î̕OSˑj
	CPartsInitialize(parentWnd,mInst);

#else
	//C-Parts̏
	CPartsInitialize(NULL);
#endif

	g_StartF=1;		//1񂵂ʂȂ悤ɂ

}

//----------------------------------//
//	C-Parts I				//
//----------------------------------//
void CPartsSI_Terminate()
{
	CPartsTerminate();
}


//----------------------------------------------//
//	shade_interfaceێ					//
//----------------------------------------------//
void CPartsSI_SetShadeInterface(shade_interface *shade)
{
	g_si_shade=shade;
}

//------------------------------------------------------//
//	Shadẻ摜C-PartsCPImageɓn					//
//	scene ... Shadescene_interfacẽ|C^			//
//	lpCPImage.. C-PartsCPImageNX̃|C^		//
//	bcol  ... CPImageNX̔wiF						//
//	mode  ... 摜̏i0..RGB , 1..Al  , 2..Zl j	//
//------------------------------------------------------//
void CPartsSI_CopyImage(scene_interface *scene,CPImage *lpCPImage,unsigned long bcol,int mode)
{
	if(!scene || !lpCPImage) return;

	int x,y;
	int rr,gg,bb;
	point_class po;
	int srcWidth,srcHeight;
	int destWidth,destHeight;
	int iWidth,iHeight;
	int PosX,PosY;
	int srcPosX,srcPosY,destPosX,destPosY;
	int numX,numY;

	lpCPImage->ClearImage(bcol);
	iWidth=lpCPImage->GetImageWidth();		//CPImage̕`̈̕
	iHeight=lpCPImage->GetImageHeight();	//CPImage̕`̈̍

	compointer<rendering_interface> render(scene->get_rendering_interface());
	if(!render) return;

	po=render->get_image_size();
	compointer<image_interface> image(render->get_image_interface());
	if(!image) return;

	//摜̃TCY
	srcWidth=(int)po.h;
	srcHeight=(int)po.v;

	if(!srcWidth || !srcHeight) return;

	if(srcWidth<=iWidth && srcHeight<=iHeight){
		//CPImage̘gɔ[܂
		PosX=(iWidth-srcWidth)>>1;
		PosY=(iHeight-srcHeight)>>1;
		destWidth=srcWidth;
		destHeight=srcHeight;
	} else {
		//CPImagẽTCYɔ[܂悤ɒ
		x=srcWidth;
		y=srcHeight;
		if(x>iWidth){
			y=iWidth*y/x;
			x=iWidth;
		}
		if(y>iHeight){
			x=iHeight*x/y;
			y=iHeight;
		}
		destWidth=x;
		destHeight=y;
		PosX=(iWidth-destWidth)>>1;
		PosY=(iHeight-destHeight)>>1;
	}

	if(image){
		//gEkĉ摜i[
		srcPosY=0;
		destPosY=PosY;
		numY=0;

		if(mode==0){
			//RGB摜ɔf------------------------
			native_rgba_class col;
			while(destPosY<destHeight+PosY){
				numX=0;
				srcPosX=0;
				destPosX=PosX;
				while(destPosX<destWidth+PosX){
					image->get_pixel(srcPosX,srcPosY,col);
					rr=(int)(col.red);
					gg=(int)(col.green);
					bb=(int)(col.blue);
					lpCPImage->SetForegroundColor(CP_RGB(rr,gg,bb));
					lpCPImage->SetPixel(destPosX,destPosY);
					destPosX++;
					numX+=srcWidth;
					while(numX>destWidth){
						numX-=destWidth;
						srcPosX++;
					}
				}
				destPosY++;
				numY+=srcHeight;
				while(numY>destHeight){
					numY-=destHeight;
					srcPosY++;
				}
			}
		} else if(mode==1){
			//Al摜ɔf-----------------------
			native_rgba_class col;
			while(destPosY<destHeight+PosY){
				numX=0;
				srcPosX=0;
				destPosX=PosX;
				while(destPosX<destWidth+PosX){
					image->get_pixel(srcPosX,srcPosY,col);
					rr=(int)(col.alpha);
					gg=(int)(col.alpha);
					bb=(int)(col.alpha);
					lpCPImage->SetForegroundColor(CP_RGB(rr,gg,bb));
					lpCPImage->SetPixel(destPosX,destPosY);
					destPosX++;
					numX+=srcWidth;
					while(numX>destWidth){
						numX-=destWidth;
						srcPosX++;
					}
				}
				destPosY++;
				numY+=srcHeight;
				while(numY>destHeight){
					numY-=destHeight;
					srcPosY++;
				}
			}

		} else if(mode==2 && image->has_z()){
			float minz,maxz,dZ;
			float z;
			//float tmp;

			//Zl摜ɔf-----------------------------

			//摜AZl̍ŏƍő߂
			//A͐`ɕϊĂȂB
			//`ɂꍇ́AZl[1/(1-z)]ŕ␳KvB
			minz=1.0f;maxz=0.0f;
			while(destPosY<destHeight+PosY){
				numX=0;
				srcPosX=0;
				destPosX=PosX;
				while(destPosX<destWidth+PosX){
					image->get_z(srcPosX,srcPosY,z);

					if(z>0.0f && z<1.0f){
						if(z<minz) minz=z;
						if(z>maxz) maxz=z;
					}

					destPosX++;
					numX+=srcWidth;
					while(numX>destWidth){
						numX-=destWidth;
						srcPosX++;
					}
				}
				destPosY++;
				numY+=srcHeight;
				while(numY>destHeight){
					numY-=destHeight;
					srcPosY++;
				}
			}

			dZ=maxz-minz;
			//擾l`ɕϊ
			//minz=1.0f/(1.0f-minz);
			//maxz=1.0f/(1.0f-maxz);
			//dZ=maxz-minz;

			//Zl摜ɔf
			srcPosY=0;
			destPosY=PosY;
			numY=0;
			while(destPosY<destHeight+PosY){
				numX=0;
				srcPosX=0;
				destPosX=PosX;
				while(destPosX<destWidth+PosX){

					image->get_z(srcPosX,srcPosY,z);

					if(z>0.0f && z<1.0f){
						rr=(int)(((z-minz)*255.0f)/dZ);
						
						//`ŋ߂ꍇ͈ȉ̎ōs
						//tmp=(1.0f/(1.0f-z));
						//rr=(int)((tmp-minz)*255.0f/(maxz-minz));
					} else {
						rr=0;
					}
					gg=bb=rr;

					lpCPImage->SetForegroundColor(CP_RGB(rr,gg,bb));
					lpCPImage->SetPixel(destPosX,destPosY);
					destPosX++;
					numX+=srcWidth;
					while(numX>destWidth){
						numX-=destWidth;
						srcPosX++;
					}
				}
				destPosY++;
				numY+=srcHeight;
				while(numY>destHeight){
					numY-=destHeight;
					srcPosY++;
				}
			}
		}
	}
}


//------------------------------------------------------//
//	Shade̎st@CN_Ƃ΃pX擾		//
//	lpFile ... fBNgt̑΃t@Cw	//
//	lpPath ... pXi[obt@			//
//	PathLen .. lpPath̃obt@TCY					//
//------------------------------------------------------//
CP_BOOL CPartsSI_GetFullPath(char *lpFile,char *lpPath,int PathLen)
{
	if(!lpPath || !lpFile) return CP_FALSE;
	if(PathLen<=0) return CP_FALSE;

	int len=0;
	
#ifdef _WINDOWS
	char szBuff[512];
	char szStr[512];
	char *lpPos=NULL;
	int i=0;

	GetModuleFileName(0,szBuff,255);	//W[itpXj̎擾

	len=strlen(szBuff);
	if(len>PathLen) return CP_FALSE;

	lpPos=strrchr(szBuff,'\\');
	if(!lpPos) return CP_FALSE;
	*lpPos='\0';

	if(*lpFile!='/' && *lpFile!='\\'){
		sprintf(szStr,"%s/%s",szBuff,lpFile);
	} else {
		strcpy(szStr,lpFile);
	}

	//'\''/'ɕϊ
	lpPos=szStr;
	for(i=0;i<len;i++){
		if(*lpPos=='\\') *lpPos='/';
		lpPos++;
	}
	len=strlen(szStr);
	if(PathLen<len) return CP_FALSE;

	strcpy(lpPath,szStr);

	return CP_TRUE;

#endif

	len=strlen(lpFile);
	if(len>PathLen) return CP_FALSE;
	strcpy(lpPath,lpFile);
	return CP_TRUE;
}



